package VASL.build.module;

import VASSAL.build.*;
import VASSAL.command.*;
import javax.swing.*;
import java.awt.event.*;

public class Tension extends AbstractBuildable
{
    
    private int index = 0;
    private int minChange = 0;
    private int maxChange = 0;
    private String MIN="", MAX="";

    public void setAttribute(String key, Object value)
    {
        if (MIN.equals(key)) {
            minChange = Integer.parseInt((String)value);   
        }
        else if (MAX.equals(key)) {
            maxChange = Integer.parseInt((String)value);   
        }
    }

    public String[] getAttributeNames()
    {
        return new String[]{MIN,MAX};
    }
    public String getAttributeValueString(String key)
    {
        if (MIN.equals(key)) {
            return ""+minChange;
        }
        else if (MAX.equals(key)) {
            return ""+maxChange;
        }
        else {
            return null;
        }
    }
    
    public void addTo(Buildable parent)
    {
        GameModule mod = (GameModule)parent;

        JButton b = new JButton("Increment");
        b.setAlignmentY(0.0F);
        b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    incrementButtonPressed();
                }});
        mod.getToolBar().add(b);
        
        b = new JButton("Show total");
        b.setAlignmentY(0.0F);
        b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    totalButtonPressed();
                }
            });
        mod.getToolBar().add(b);
        GameModule.getGameModule().addCommandEncoder((CommandEncoder)this);
    }

    /*public static class Incr extends Command
    {
        private Tension target;
        private int change;

        public Incr(Tension target, int change)
        {
            this.target = target;
            this.change = change;
        }       
        protected void executeCommand() {
            target.addToIndex(change);
        }
        protected Command myUndoCommand() {
            return new Incr(target,-change);
        }       
        public int getChange() {
            return change;
        }
    }*/

    private void incrementButtonPressed() {
        /*GameModule mod = GameModule.getGameModule();
        int change = newIncrement();
        Command c = new
            Chatter.DisplayText(mod.getChatter(),"Tension changes by "+change);
        c.append(new Incr(this,change));
        c.execute();
        mod.sendAndLog(c);*/
    }

    private void totalButtonPressed() {
        GameModule.getGameModule().getChatter().show("Tension index is "+index);
    }

    public static final String COMMAND_PREFIX = "TENSION:";
    
    /*public String encode(Command c) {
        if (c instanceof Incr) {
            return COMMAND_PREFIX+((Incr)c).getChange();
        }
        else {
            return null;
        }
    }*/
    
    /*public Command decode(String s) {
        if (s.startsWith(COMMAND_PREFIX)) {
            return new Incr(this,Integer.parseInt(s.substring(COMMAND_PREFIX.length())));
        }
        else {
            return null;
        }
    }*/
    
    public void setup(boolean gameStarting) {
        if (!gameStarting) {
            index = 0;
        }
    }

    /*public Command getRestoreCommand() {
        return new Incr(this,index);
    }*/

}